Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/INSTALL.rst
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/INSTALL.rst	(revision 14021)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/INSTALL.rst	(revision 14022)
@@ -122,5 +122,5 @@
 .. code:: console
 
-   $ svn co https://forge.ipsl.jussieu.fr/nemo/svn/NEMO/trunk
+   $ svn co https://forge.ipsl.jussieu.fr/nemo/svn/NEMO/releases/r4.0/r4.0.4
 
 Description of 1\ :sup:`st` level tree structure
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/cfgs/SHARED/namelist_ref
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/cfgs/SHARED/namelist_ref	(revision 14021)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/cfgs/SHARED/namelist_ref	(revision 14022)
@@ -274,5 +274,5 @@
          rn_stau_a = -2.9e-3   !     Alpha from eq. 10: Stau = Alpha * Wnd + Beta
          rn_stau_b =  8.0e-3   !     Beta 
-   !   
+   !
    ln_humi_sph = .true.  !  humidity "sn_humi" is specific humidity  [kg/kg]
    ln_humi_dpt = .false. !  humidity "sn_humi" is dew-point temperature [K]
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk.F90
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk.F90	(revision 14021)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/src/OCE/SBC/sbcblk.F90	(revision 14022)
@@ -56,6 +56,4 @@
    USE sbcblk_algo_andreas  ! => turb_andreas  : Andreas et al. 2015
    !
-
-   !
    USE iom            ! I/O manager library
    USE in_out_manager ! I/O manager
@@ -413,7 +411,7 @@
          WRITE(numout,*) '      use surface current feedback on wind stress         ln_crt_fbk   = ', ln_crt_fbk
          IF(ln_crt_fbk) THEN
-            WRITE(numout,*) '         Renault et al. 2020, eq. 10: Stau = Alpha * Wnd + Beta'
-            WRITE(numout,*) '            Alpha                                         rn_stau_a    = ', rn_stau_a
-            WRITE(numout,*) '            Beta                                          rn_stau_b    = ', rn_stau_b
+         WRITE(numout,*) '         Renault et al. 2020, eq. 10: Stau = Alpha * Wnd + Beta'
+         WRITE(numout,*) '            Alpha                                         rn_stau_a    = ', rn_stau_a
+         WRITE(numout,*) '            Beta                                          rn_stau_b    = ', rn_stau_b
          ENDIF
          !
@@ -1135,53 +1133,50 @@
          DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
 
-         zst = ptsu(ji,jj,jl)                           ! surface temperature of sea-ice [K]
-         zsq = q_sat( zst, pslp(ji,jj), l_ice=.TRUE. )  ! surface saturation specific humidity when ice present
-
-         ! ----------------------------!
-         !      I   Radiative FLUXES   !
-         ! ----------------------------!
-         ! Short Wave (sw)
-         qsr_ice(ji,jj,jl) = zztmp * ( 1. - palb(ji,jj,jl) ) * qsr(ji,jj)
-
-         ! Long  Wave (lw)
-         zst3 = zst * zst * zst
-         z_qlw(ji,jj,jl)   = emiss_i * ( pdqlw(ji,jj) - stefan * zst * zst3 ) * tmask(ji,jj,1)
-         ! lw sensitivity
-         z_dqlw(ji,jj,jl)  = zcoef_dqlw * zst3
-
-         ! ----------------------------!
-         !     II    Turbulent FLUXES  !
-         ! ----------------------------!
-
-         ! ... turbulent heat fluxes with Ch_ice recalculated in blk_ice_1
-
-         ! Common term in bulk F. equations...
-         zzblk = rhoa(ji,jj) * wndm_ice(ji,jj)
-
-         ! Sensible Heat
-         zztmp1 = zzblk * rCp_air * Ch_ice(ji,jj)
-         z_qsb (ji,jj,jl) = zztmp1 * (zst - theta_zu_i(ji,jj))
-         z_dqsb(ji,jj,jl) = zztmp1                        ! ==> Qsens sensitivity (Dqsb_ice/Dtn_ice)
-
-         ! Latent Heat
-         zztmp1 = zzblk * rLsub * Ce_ice(ji,jj)
-         qla_ice(ji,jj,jl) = MAX( zztmp1 * (zsq - q_zu_i(ji,jj)) , 0._wp )   ! #LB: only sublimation (and not condensation) ???
-         IF(qla_ice(ji,jj,jl)>0._wp) dqla_ice(ji,jj,jl) = zztmp1*dq_sat_dt_ice(zst, pslp(ji,jj)) ! ==> Qlat sensitivity  (dQlat/dT)
-         !                                                                                       !#LB: dq_sat_dt_ice() in "sbc_phy.F90"
-         !#LB: without this unjustified "condensation sensure":
-         !qla_ice( ji,jj,jl) = zztmp1 * (zsq - q_zu_i(ji,jj))
-         !dqla_ice(ji,jj,jl) = zztmp1 * dq_sat_dt_ice(zst, pslp(ji,jj)) ! ==> Qlat sensitivity  (dQlat/dT)
-
-
-
-         ! ----------------------------!
-         !     III    Total FLUXES     !
-         ! ----------------------------!
-
-         ! Downward Non Solar flux
-         qns_ice (ji,jj,jl) =     z_qlw (ji,jj,jl) - z_qsb (ji,jj,jl) - qla_ice (ji,jj,jl)
-
-         ! Total non solar heat flux sensitivity for ice
-         dqns_ice(ji,jj,jl) = - ( z_dqlw(ji,jj,jl) + z_dqsb(ji,jj,jl) + dqla_ice(ji,jj,jl) ) !#LB: correct signs ????
+               zst = ptsu(ji,jj,jl)                           ! surface temperature of sea-ice [K]
+               zsq = q_sat( zst, pslp(ji,jj), l_ice=.TRUE. )  ! surface saturation specific humidity when ice present
+
+               ! ----------------------------!
+               !      I   Radiative FLUXES   !
+               ! ----------------------------!
+               ! Short Wave (sw)
+               qsr_ice(ji,jj,jl) = zztmp * ( 1. - palb(ji,jj,jl) ) * qsr(ji,jj)
+
+               ! Long  Wave (lw)
+               zst3 = zst * zst * zst
+               z_qlw(ji,jj,jl)   = emiss_i * ( pdqlw(ji,jj) - stefan * zst * zst3 ) * tmask(ji,jj,1)
+               ! lw sensitivity
+               z_dqlw(ji,jj,jl)  = zcoef_dqlw * zst3
+
+               ! ----------------------------!
+               !     II    Turbulent FLUXES  !
+               ! ----------------------------!
+
+               ! ... turbulent heat fluxes with Ch_ice recalculated in blk_ice_1
+
+               ! Common term in bulk F. equations...
+               zzblk = rhoa(ji,jj) * wndm_ice(ji,jj)
+
+               ! Sensible Heat
+               zztmp1 = zzblk * rCp_air * Ch_ice(ji,jj)
+               z_qsb (ji,jj,jl) = zztmp1 * (zst - theta_zu_i(ji,jj))
+               z_dqsb(ji,jj,jl) = zztmp1                        ! ==> Qsens sensitivity (Dqsb_ice/Dtn_ice)
+
+               ! Latent Heat
+               zztmp1 = zzblk * rLsub * Ce_ice(ji,jj)
+               qla_ice(ji,jj,jl) = MAX( zztmp1 * (zsq - q_zu_i(ji,jj)) , 0._wp )   ! #LB: only sublimation (and not condensation) ???
+               IF(qla_ice(ji,jj,jl)>0._wp) dqla_ice(ji,jj,jl) = zztmp1*dq_sat_dt_ice(zst, pslp(ji,jj)) ! ==> Qlat sensitivity  (dQlat/dT)
+               !                                                                                       !#LB: dq_sat_dt_ice() in "sbc_phy.F90"
+               !#LB: without this unjustified "condensation sensure":
+               !qla_ice( ji,jj,jl) = zztmp1 * (zsq - q_zu_i(ji,jj))
+               !dqla_ice(ji,jj,jl) = zztmp1 * dq_sat_dt_ice(zst, pslp(ji,jj)) ! ==> Qlat sensitivity  (dQlat/dT)
+
+
+               ! ----------------------------!
+               !     III    Total FLUXES     !
+               ! ----------------------------!
+               ! Downward Non Solar flux
+               qns_ice (ji,jj,jl) =     z_qlw (ji,jj,jl) - z_qsb (ji,jj,jl) - qla_ice (ji,jj,jl)
+               ! Total non solar heat flux sensitivity for ice
+               dqns_ice(ji,jj,jl) = - ( z_dqlw(ji,jj,jl) + z_dqsb(ji,jj,jl) + dqla_ice(ji,jj,jl) ) !#LB: correct signs ????
 
          END_2D